<?php
 /**
 * This Software is the property of Data Development and is protected
 * by copyright law - it is NOT Freeware.
 *
 * Any unauthorized use of this software without a valid license
 * is a violation of the license agreement and will be prosecuted by
 * civil and criminal law.
 *
 * http://www.shopmodule.com
 *
 * @copyright  D Data Development, Thomas Dartsch
 * @author    D Data Development - Daniel Seifert <ds@shopmodule.com>
 * @link      http://www.oxidmodule.com
 */

class d3_oxwarticledetails_extsearch extends d3_oxwarticledetails_extsearch_parent
{
    public $oD3SearchHandler = null;
    protected $_aSelectedAttributes;

    public function init()
    {
        if (false == is_array($this->_aComponentNames)) {
            $this->_aComponentNames = array();
        }

        if (false == in_array('oxcmp_utils', array_change_key_case(array_keys($this->_aComponentNames)), CASE_LOWER)) {
            $this->_aComponentNames['oxcmp_utils'] = 1;
        }

        parent::init();
    }

    /**
     * performance, use a class wide instance
     *
     * @return d3_oxsearch_extsearch
     */
    protected function _d3GetSearchHandler()
    {
        if (!$this->oD3SearchHandler) {
            $this->oD3SearchHandler = oxNew('oxsearch');
        }

        return $this->oD3SearchHandler;
    }

    /**
     * @return array
     */
    public function d3GetPriceFilters()
    {
        return $this->_d3GetSearchHandler()->getPriceSelectors();
    }

    /**
     * @return array
     */
    public function d3GetAttributeFilters()
    {
        return $this->getAttributeFilters();
    }

    /**
     * @return array
     */
    public function getAttributeFilters()
    {
        if (null == $this->_aSelectedAttributes) {
            $this->_aSelectedAttributes = $this->_d3GetSearchHandler()->getAttributeFilters();

            /*
            foreach ($this->_aSelectedAttributes as $sKey => $mValue) {
                if (is_array($mValue) && count($mValue)) {
                    foreach ($mValue as $iIdent => $sValue) {
                        $sAddStr = "&amp;d3searchattribmulti[$sKey][$iIdent]=" . urlencode(trim($sValue));
                    }
                } elseif (is_string($mValue) && trim($mValue)) {
                    $sAddStr = "&amp;d3searchattrib[$sKey]=" . urlencode(trim($mValue));
                }
            }
            */

            $this->addTplParam('aD3AttribFilters', $this->_aSelectedAttributes);
        }

        return $this->_aSelectedAttributes;
    }

    /**
     * @return mixed
     */
    public function d3getFilterPageId()
    {
        switch (strtolower($this->getListType())) {
            case 'search':
                $sClassNameAdd = 'search##';
                $sIdent = md5(rawurlencode(strtolower(oxRegistry::getConfig()->getRequestParameter('searchparam', true))));
                break;
            case 'manufacturer':
                $sClassNameAdd = '##';
                $sIdent = oxRegistry::getConfig()->getRequestParameter('mnid');
                break;
            default:
                $sClassNameAdd = '##';
                $sIdent = oxRegistry::getConfig()->getRequestParameter('cnid');
        }

        $sPageId = $sClassNameAdd.
            oxRegistry::getLang()->getLanguageAbbr()."##".
            oxRegistry::getConfig()->getShopId()."##".
            $sIdent;

        return $sPageId;
    }

    /**
     * @return array
     */
    public function getNavigationParams()
    {
        $aParams = parent::getNavigationParams();

        $sListType = $this->getConfig()->getRequestParameter('listtype');
        /** @var d3_ext_search $oSearch */
        if ('search' == $sListType) {
            $oSearch = oxNew('search');
        } elseif ('vendor' == $sListType) {
            $oSearch = oxNew('vendorlist');
        } elseif ('manufacturer' == $sListType) {
            $oSearch = oxNew('manufacturerlist');
        } else {
            $oSearch = oxNew('alist');
        }
        $aSearchParams = $oSearch->getNavigationParams();

        $aParams = array_merge($aSearchParams, $aParams);

        return $aParams;
    }

    /**
     * @return bool
     */
    public function d3CategoryFilterUseMultipleValues()
    {
        return $this->_d3GetSearchHandler()->d3CategoryFilterUseMultipleValues();
    }

    public function d3GetCategoryMultiFilter()
    {
        /*
        $sListType = $this->getConfig()->getRequestParameter('listtype');
        if ('search' == $sListType) {

        } else {
        }*/

        /** @var d3_alist_extsearch $oSearch */
        $oSearch = oxNew('alist');
        return $oSearch->d3GetCategoryMultiFilter();
    }

    /**
     * @return bool
     */
    public function d3VendorFilterUseMultipleValues()
    {
        return $this->_d3GetSearchHandler()->d3VendorFilterUseMultipleValues();
    }

    public function d3GetVendorMultiFilter()
    {
        /*
        $sListType = $this->getConfig()->getRequestParameter('listtype');
        if ('search' == $sListType) {

        } else {
        }*/

        /** @var d3_alist_extsearch $oSearch */
        $oSearch = oxNew('alist');
        return $oSearch->d3GetVendorMultiFilter();
    }

    /**
     * @return bool
     */
    public function d3ManufacturerFilterUseMultipleValues()
    {
        return $this->_d3GetSearchHandler()->d3ManufacturerFilterUseMultipleValues();
    }

    public function d3GetManufacturerMultiFilter()
    {
        /*
        $sListType = $this->getConfig()->getRequestParameter('listtype');
        if ('search' == $sListType) {

        } else {
        }*/

        /** @var d3_alist_extsearch $oSearch */
        $oSearch = oxNew('alist');
        return $oSearch->d3GetManufacturerMultiFilter();
    }

    /**
     * @return bool|string
     */
    public function getSearchCategory()
    {
        return rawurldecode($this->getConfig()->getRequestParameter('searchcnid'));
    }

    /**
     * @return string
     */
    public function getSearchVendor()
    {
        return rawurldecode($this->getConfig()->getRequestParameter('searchvendor'));
    }

    /**
     * @return string
     */
    public function getSearchManufacturer()
    {
        return rawurldecode($this->getConfig()->getRequestParameter('searchmanufacturer'));
    }
}
